/*
 * This software is Copyright 1987 by Stan Barber. 
 *
 * Permission is hereby granted to copy, reproduce, redistribute or otherwise
 * use this software as long as: there is no monetary profit gained
 * specifically from the use or reproduction or this software, it is not
 * sold, rented, traded or otherwise marketed, and this copyright notice is
 * included prominently in any copy made. 
 *
 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

extern FILE *default_ser_fps[2];
#define ser_rd_fp	default_ser_fps[0]
#define ser_wr_fp	default_ser_fps[1]
static int sockt_rd;
static int sockt_wr;

/*
 * server_init  Get a connection to the remote news server.
 *
 *	Parameters:	"machine" is the machine to connect to.
 *
 *	Returns:	-1 on error
 *			server's initial response code on success.
 *
 *	Side effects:	Connects to server.
 *			"ser_rd_fp" and "ser_wr_fp" are fp's
 *			for reading and writing to server.
 */

nntp_server_done(opennow){
	if( opennow && 0 <= sockt_rd)
		close_server();
	sockt_rd = 0;
}
nntp_server_init0(machine,portname)
	char *machine,*portname;
{
	if( sockt_rd == 0 )
		sockt_rd = get_tcp_socket1(machine,portname,0);
	if (sockt_rd < 0) {
		printf(">>>> server_init: get_tcp_socket(%s,%s)\n",
			machine,portname);
		printf(">>>> cannot get tcp socket.\n");
		return -1;
	}
}

nntp_server_init1(machine,portname)
	char	*machine,*portname;
{	char	*index();
 
	if( sockt_rd == 0 )
		nntp_server_init0(machine,portname);
	if (sockt_rd < 0)
		return -1;

	if ((ser_rd_fp = fdopen(sockt_rd, "r")) == NULL) {
		perror("server_init: fdopen #1");
		return (-1);
	}
	sockt_wr = dup(sockt_rd);
	if ((ser_wr_fp = fdopen(sockt_wr, "w")) == NULL) {
		perror("server_init: fdopen #2");
		ser_rd_fp = NULL;		/* from above */
		return (-1);
	}
	return 0;
}

FILE *
nntp_server_fp(){ return ser_rd_fp; }
